# coding: utf-8

"""
    EPIC API

    REST API for interacting with EPIC (https://epic.zenotech.com) services. <br />                             Please note this API is in BETA and does not yet contain                             all EPIC functionality.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@zenotech.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from epiccore.configuration import Configuration


class ApplicationConfigurationSerialiser(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'start_script': 'Template',
        'stop_script': 'Template',
        'created': 'datetime',
        'modified': 'datetime',
        'default_mpi_command': 'str'
    }

    attribute_map = {
        'start_script': 'start_script',
        'stop_script': 'stop_script',
        'created': 'created',
        'modified': 'modified',
        'default_mpi_command': 'default_mpi_command'
    }

    def __init__(self, start_script=None, stop_script=None, created=None, modified=None, default_mpi_command=None, local_vars_configuration=None):  # noqa: E501
        """ApplicationConfigurationSerialiser - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._start_script = None
        self._stop_script = None
        self._created = None
        self._modified = None
        self._default_mpi_command = None
        self.discriminator = None

        self.start_script = start_script
        self.stop_script = stop_script
        if created is not None:
            self.created = created
        if modified is not None:
            self.modified = modified
        self.default_mpi_command = default_mpi_command

    @property
    def start_script(self):
        """Gets the start_script of this ApplicationConfigurationSerialiser.  # noqa: E501


        :return: The start_script of this ApplicationConfigurationSerialiser.  # noqa: E501
        :rtype: Template
        """
        return self._start_script

    @start_script.setter
    def start_script(self, start_script):
        """Sets the start_script of this ApplicationConfigurationSerialiser.


        :param start_script: The start_script of this ApplicationConfigurationSerialiser.  # noqa: E501
        :type start_script: Template
        """
        if self.local_vars_configuration.client_side_validation and start_script is None:  # noqa: E501
            raise ValueError("Invalid value for `start_script`, must not be `None`")  # noqa: E501

        self._start_script = start_script

    @property
    def stop_script(self):
        """Gets the stop_script of this ApplicationConfigurationSerialiser.  # noqa: E501


        :return: The stop_script of this ApplicationConfigurationSerialiser.  # noqa: E501
        :rtype: Template
        """
        return self._stop_script

    @stop_script.setter
    def stop_script(self, stop_script):
        """Sets the stop_script of this ApplicationConfigurationSerialiser.


        :param stop_script: The stop_script of this ApplicationConfigurationSerialiser.  # noqa: E501
        :type stop_script: Template
        """
        if self.local_vars_configuration.client_side_validation and stop_script is None:  # noqa: E501
            raise ValueError("Invalid value for `stop_script`, must not be `None`")  # noqa: E501

        self._stop_script = stop_script

    @property
    def created(self):
        """Gets the created of this ApplicationConfigurationSerialiser.  # noqa: E501


        :return: The created of this ApplicationConfigurationSerialiser.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this ApplicationConfigurationSerialiser.


        :param created: The created of this ApplicationConfigurationSerialiser.  # noqa: E501
        :type created: datetime
        """

        self._created = created

    @property
    def modified(self):
        """Gets the modified of this ApplicationConfigurationSerialiser.  # noqa: E501


        :return: The modified of this ApplicationConfigurationSerialiser.  # noqa: E501
        :rtype: datetime
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """Sets the modified of this ApplicationConfigurationSerialiser.


        :param modified: The modified of this ApplicationConfigurationSerialiser.  # noqa: E501
        :type modified: datetime
        """

        self._modified = modified

    @property
    def default_mpi_command(self):
        """Gets the default_mpi_command of this ApplicationConfigurationSerialiser.  # noqa: E501


        :return: The default_mpi_command of this ApplicationConfigurationSerialiser.  # noqa: E501
        :rtype: str
        """
        return self._default_mpi_command

    @default_mpi_command.setter
    def default_mpi_command(self, default_mpi_command):
        """Sets the default_mpi_command of this ApplicationConfigurationSerialiser.


        :param default_mpi_command: The default_mpi_command of this ApplicationConfigurationSerialiser.  # noqa: E501
        :type default_mpi_command: str
        """
        if self.local_vars_configuration.client_side_validation and default_mpi_command is None:  # noqa: E501
            raise ValueError("Invalid value for `default_mpi_command`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                default_mpi_command is not None and len(default_mpi_command) > 300):
            raise ValueError("Invalid value for `default_mpi_command`, length must be less than or equal to `300`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                default_mpi_command is not None and len(default_mpi_command) < 1):
            raise ValueError("Invalid value for `default_mpi_command`, length must be greater than or equal to `1`")  # noqa: E501

        self._default_mpi_command = default_mpi_command

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationConfigurationSerialiser):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApplicationConfigurationSerialiser):
            return True

        return self.to_dict() != other.to_dict()
