# coding: utf-8

"""
    EPIC API

    REST API for interacting with EPIC (https://epic.zenotech.com) services. <br />                             Please note this API is in BETA and does not yet contain                             all EPIC functionality.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@zenotech.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from epiccore.configuration import Configuration


class SessionToken(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'aws_key_id': 'str',
        'aws_secret_key': 'str',
        'aws_session_token': 'str',
        'expiration': 'datetime'
    }

    attribute_map = {
        'aws_key_id': 'aws_key_id',
        'aws_secret_key': 'aws_secret_key',
        'aws_session_token': 'aws_session_token',
        'expiration': 'expiration'
    }

    def __init__(self, aws_key_id=None, aws_secret_key=None, aws_session_token=None, expiration=None, local_vars_configuration=None):  # noqa: E501
        """SessionToken - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._aws_key_id = None
        self._aws_secret_key = None
        self._aws_session_token = None
        self._expiration = None
        self.discriminator = None

        if aws_key_id is not None:
            self.aws_key_id = aws_key_id
        if aws_secret_key is not None:
            self.aws_secret_key = aws_secret_key
        if aws_session_token is not None:
            self.aws_session_token = aws_session_token
        if expiration is not None:
            self.expiration = expiration

    @property
    def aws_key_id(self):
        """Gets the aws_key_id of this SessionToken.  # noqa: E501

        AWS Access Key  # noqa: E501

        :return: The aws_key_id of this SessionToken.  # noqa: E501
        :rtype: str
        """
        return self._aws_key_id

    @aws_key_id.setter
    def aws_key_id(self, aws_key_id):
        """Sets the aws_key_id of this SessionToken.

        AWS Access Key  # noqa: E501

        :param aws_key_id: The aws_key_id of this SessionToken.  # noqa: E501
        :type aws_key_id: str
        """
        if (self.local_vars_configuration.client_side_validation and
                aws_key_id is not None and len(aws_key_id) < 1):
            raise ValueError("Invalid value for `aws_key_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._aws_key_id = aws_key_id

    @property
    def aws_secret_key(self):
        """Gets the aws_secret_key of this SessionToken.  # noqa: E501

        AWS Secret Key  # noqa: E501

        :return: The aws_secret_key of this SessionToken.  # noqa: E501
        :rtype: str
        """
        return self._aws_secret_key

    @aws_secret_key.setter
    def aws_secret_key(self, aws_secret_key):
        """Sets the aws_secret_key of this SessionToken.

        AWS Secret Key  # noqa: E501

        :param aws_secret_key: The aws_secret_key of this SessionToken.  # noqa: E501
        :type aws_secret_key: str
        """
        if (self.local_vars_configuration.client_side_validation and
                aws_secret_key is not None and len(aws_secret_key) < 1):
            raise ValueError("Invalid value for `aws_secret_key`, length must be greater than or equal to `1`")  # noqa: E501

        self._aws_secret_key = aws_secret_key

    @property
    def aws_session_token(self):
        """Gets the aws_session_token of this SessionToken.  # noqa: E501


        :return: The aws_session_token of this SessionToken.  # noqa: E501
        :rtype: str
        """
        return self._aws_session_token

    @aws_session_token.setter
    def aws_session_token(self, aws_session_token):
        """Sets the aws_session_token of this SessionToken.


        :param aws_session_token: The aws_session_token of this SessionToken.  # noqa: E501
        :type aws_session_token: str
        """
        if (self.local_vars_configuration.client_side_validation and
                aws_session_token is not None and len(aws_session_token) < 1):
            raise ValueError("Invalid value for `aws_session_token`, length must be greater than or equal to `1`")  # noqa: E501

        self._aws_session_token = aws_session_token

    @property
    def expiration(self):
        """Gets the expiration of this SessionToken.  # noqa: E501

        Expiration time of token  # noqa: E501

        :return: The expiration of this SessionToken.  # noqa: E501
        :rtype: datetime
        """
        return self._expiration

    @expiration.setter
    def expiration(self, expiration):
        """Sets the expiration of this SessionToken.

        Expiration time of token  # noqa: E501

        :param expiration: The expiration of this SessionToken.  # noqa: E501
        :type expiration: datetime
        """

        self._expiration = expiration

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SessionToken):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SessionToken):
            return True

        return self.to_dict() != other.to_dict()
